SystemOrganization addCategory: #TimeHashing!

Object subclass: #DateAndTimeHashing
	instanceVariableNames: 'offsets times arrayToTest hashDictionary'
	classVariableNames: 'AllInstancesDataSet RandomDataSet SequentialDataSet'
	poolDictionaries: ''
	category: 'TimeHashing'!

DateAndTimeHashing class
	instanceVariableNames: 'offsets'!

DateAndTimeHashing class
	instanceVariableNames: 'offsets'!

!DateAndTimeHashing class methodsFor: 'benchmarking' stamp: 'PaulDeBruicker 5/13/2012 23:48'!
benchmarkAllInstancesHashing
	self new
		arrayToTest: DateAndTime allInstances asSet;
		runBenchmark! !

!DateAndTimeHashing class methodsFor: 'benchmarking' stamp: 'PaulDeBruicker 5/13/2012 22:37'!
benchmarkRandomHashing
	self new
		arrayToTest: RandomDataSet;
		runBenchmark! !

!DateAndTimeHashing class methodsFor: 'benchmarking' stamp: 'PaulDeBruicker 5/13/2012 22:37'!
benchmarkSequentialHashing
	self new
		arrayToTest: SequentialDataSet;
		runBenchmark! !

!DateAndTimeHashing class methodsFor: 'benchmarking' stamp: 'PaulDeBruicker 5/13/2012 23:15'!
benchmarkTwoDataSets
	self new
		arrayToTest: RandomDataSet , SequentialDataSet;
		runBenchmark! !

!DateAndTimeHashing class methodsFor: 'datasets' stamp: 'PaulDeBruicker 5/13/2012 22:55'!
days
	^ 366! !

!DateAndTimeHashing class methodsFor: 'datasets' stamp: 'PaulDeBruicker 5/13/2012 23:45'!
eraseDataSets
	RandomDataSet := nil.
	SequentialDataSet := nil.
	Smalltalk garbageCollect! !

!DateAndTimeHashing class methodsFor: 'datasets' stamp: 'PaulDeBruicker 5/13/2012 23:34'!
initialize
	self initializeOffsets.
	self refreshDataSets! !

!DateAndTimeHashing class methodsFor: 'datasets' stamp: 'PaulDeBruicker 5/13/2012 22:10'!
initializeOffsets
	| initialOffset hrs |
	hrs := 0 to: 1560 by: 30.
	initialOffset := Duration hours: -12.
	offsets := OrderedCollection new.
	hrs do: [ :eachHalfHour | self offsets add: initialOffset + eachHalfHour minutes ].
	self offsets add: (Duration minutes: 345).	"nepal"
	self offsets add: (Duration minutes: 765)	"chatham islands"! !

!DateAndTimeHashing class methodsFor: 'datasets' stamp: 'PaulDeBruicker 5/13/2012 22:09'!
jdns
	^ 3660000! !

!DateAndTimeHashing class methodsFor: 'datasets' stamp: 'PaulDeBruicker 5/13/2012 22:10'!
nanos
	^ 1000000000! !

!DateAndTimeHashing class methodsFor: 'datasets' stamp: 'PaulDeBruicker 5/13/2012 22:22'!
newRandomDateAndTimeDataSet
	| now |
	now := DateAndTime now.
	RandomDataSet := Array new: self randomIterations.
	(Interval from: 1 to: self randomIterations)
		do: [ :eachIteration | 
			RandomDataSet
				at: eachIteration
				put:
					(now
						setJdn: self jdns random
						seconds: self seconds random
						nano: self nanos random
						offset: (self offsets at: 1 + 55 random)) copy ]! !

!DateAndTimeHashing class methodsFor: 'datasets' stamp: 'PaulDeBruicker 5/13/2012 22:37'!
newSequentialDateAndTimeDataSet
	| randomStartTime iterationInterval set |
	SequentialDataSet := OrderedCollection new.
	set := Set new.
	iterationInterval := Interval from: 1 to: self sequentialIterations.
	randomStartTime := self randomDateAndTime.
	self sequentialStepSizes
		do: [ :eachStepSize | 
			iterationInterval
				do: [ :each | 
					| newTime |
					newTime := randomStartTime + (eachStepSize * each).
					(set includes: newTime)
						ifFalse: [ 
							set add: newTime.
							SequentialDataSet add: newTime ] ] ]! !

!DateAndTimeHashing class methodsFor: 'accessing' stamp: 'PaulDeBruicker 5/13/2012 22:11'!
offsets
	^ offsets! !

!DateAndTimeHashing class methodsFor: 'datasets' stamp: 'PaulDeBruicker 5/13/2012 22:24'!
randomDateAndTime
	^ DateAndTime new
		setJdn: self jdns random
		seconds: self seconds random
		nano: self nanos random
		offset: (self offsets at: 1 + 51 random)! !

!DateAndTimeHashing class methodsFor: 'datasets-iterations' stamp: 'PaulDeBruicker 5/14/2012 00:14'!
randomIterations
	^ 100! !

!DateAndTimeHashing class methodsFor: 'datasets' stamp: 'PaulDeBruicker 5/13/2012 23:15'!
refreshDataSets
	self eraseDataSets.
	3 timesRepeat: [ Smalltalk garbageCollect ].
	self
		newRandomDateAndTimeDataSet;
		newSequentialDateAndTimeDataSet! !

!DateAndTimeHashing class methodsFor: 'collision-testing' stamp: 'PaulDeBruicker 5/13/2012 23:47'!
runAllInstancesHashing
	| hD |
	hD := self new
		arrayToTest: DateAndTime allInstances asSet;
		runHashing.
	Transcript
		cr;
		show: hD collisionRate.
	^ hD! !

!DateAndTimeHashing class methodsFor: 'collision-testing' stamp: 'PaulDeBruicker 5/13/2012 23:31'!
runRandomHashing
	| hD |
	hD := self new
		arrayToTest: RandomDataSet;
		runHashing.
	Transcript
		cr;
		show: hD collisionRate.
	^ hD! !

!DateAndTimeHashing class methodsFor: 'collision-testing' stamp: 'PaulDeBruicker 5/13/2012 23:31'!
runSequentialHashing
	| hD |
	hD := self new
		arrayToTest: SequentialDataSet;
		runHashing.
	Transcript
		cr;
		show: hD collisionRate.
	^ hD! !

!DateAndTimeHashing class methodsFor: 'datasets' stamp: 'PaulDeBruicker 5/13/2012 22:56'!
seconds
	^ 86400! !

!DateAndTimeHashing class methodsFor: 'datasets-iterations' stamp: 'PaulDeBruicker 5/14/2012 00:14'!
sequentialIterations
	^ 15! !

!DateAndTimeHashing class methodsFor: 'datasets-iterations' stamp: 'PaulDeBruicker 5/14/2012 00:05'!
sequentialStepSizes
	^ {(1 second).
	(1 minute).
	(1 hour).
	(1 day).
	(1 week).
	(30 days).
	(1 year)}! !

!DateAndTimeHashing class methodsFor: 'datasets' stamp: 'PaulDeBruicker 5/13/2012 22:56'!
years
	^ 5000! !

!DateAndTimeHashing methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 5/13/2012 22:54'!
arrayToTest
	^ arrayToTest! !

!DateAndTimeHashing methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 5/13/2012 22:54'!
arrayToTest: anArray
	arrayToTest := anArray! !

!DateAndTimeHashing methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 5/13/2012 23:30'!
collisionRate
	^ self collisions size / self arrayToTest size! !

!DateAndTimeHashing methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 5/13/2012 22:54'!
collisions
	^ self hashDictionary values select: [ :each | each size > 1 ]! !

!DateAndTimeHashing methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 5/13/2012 22:54'!
hashDictionary
	^ hashDictionary! !

!DateAndTimeHashing methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 5/13/2012 21:29'!
hashOf: aDateAndTime
	"new: 
	| jdn second offset nano totalSeconds |
	jdn := aDateAndTime julianDayNumber.
	second := aDateAndTime secondsSinceMidnight.
	offset := aDateAndTime offset.
	nano := aDateAndTime nanoSecond.
	totalSeconds := second - offset asSeconds.	
	^ ((totalSeconds // 86400 + jdn) hashMultiply bitXor: totalSeconds \\ 86400) bitXor: nano
	
	old: 
	^ aDateAndTime asUTC ticks hash
	"

	| jdn second offset nano totalSeconds |
	jdn := aDateAndTime julianDayNumber.
	second := aDateAndTime secondsSinceMidnight.
	offset := aDateAndTime offset.
	nano := aDateAndTime nanoSecond.
	totalSeconds := second - offset asSeconds.
	^ ((totalSeconds // 86400 + jdn) hashMultiply bitXor: totalSeconds \\ 86400) bitXor: nano! !

!DateAndTimeHashing methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 5/13/2012 22:55'!
noLargePositiveIntegerHashes
	^ self hashDictionary keys allSatisfy: [ :each | each isLarge not ]! !

!DateAndTimeHashing methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 5/13/2012 22:55'!
numberOfCollisions
	^ self arrayToTest size - self hashDictionary keys size! !

!DateAndTimeHashing methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 5/13/2012 22:55'!
runBenchmark
	Smalltalk garbageCollect.
	TimeProfileBrowser spyOn: [ self arrayToTest do: [ :eachTime | self hashOf: eachTime ] ]! !

!DateAndTimeHashing methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 5/13/2012 22:55'!
runHashing
	hashDictionary := Dictionary new.
	self arrayToTest
		do: [ :eachTime | (hashDictionary at: (self hashOf: eachTime) ifAbsentPut: [ OrderedCollection new ]) add: eachTime ]! !
DateAndTimeHashing initialize!
